package fi.cas.task;

import com.alibaba.druid.support.logging.Log;
import com.alibaba.druid.support.logging.LogFactory;
import fi.cas.opplugin.PayBillToolUtil;
import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.exception.KDException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.schedule.executor.AbstractTask;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import org.json.JSONObject;

import java.util.Map;

public class PayQueryStatusTast extends AbstractTask {
    private static final Log log = LogFactory.getLog(PayQueryStatusTast.class);
    @Override
    public void execute(RequestContext requestContext, Map<String, Object> map) throws KDException {
        //获取要查询的数据。状态为已审批，支付状态为支付中。
        QFilter filter = new QFilter("billstatus", QCP.equals, "C");
        filter.and("nckd_paystatus", QCP.equals, "2");
        filter.and("nckd_fkcs", QCP.large_than, 0);
        DynamicObject[] payinfos = BusinessDataServiceHelper.load("cas_paybill","billno,billstatus,nckd_paystatus,nckd_sbyy,nckd_fqqdrq,nckd_fkcs,nckd_bbh", new QFilter[] {filter});
        DynamicObject jkpzxx = BusinessDataServiceHelper.loadSingle("nckd_jkpzxx",new QFilter[]{new QFilter("number","=","paytozfqz")});
        String servername =  jkpzxx.getString("nckd_servername");
        String port =  jkpzxx.getString("nckd_port");

        for (DynamicObject dataEntity : payinfos) {
            //调用接口查询付款状态
            String bodyxml = PayBillToolUtil.queryPaymentRequest(dataEntity);
            String billNum = dataEntity.getString("billno");
            log.info("单据号："+billNum+"传入参数"+bodyxml);
            JSONObject cbsReturnJson =PayBillToolUtil.socketServiceQuery(servername,port,bodyxml,"BTSQO001");
            log.info("单据号："+billNum+"返回参数"+cbsReturnJson.toString());
            if(cbsReturnJson==null||cbsReturnJson.get("Message")==null){
            }else{
                JSONObject bodyinfo = cbsReturnJson.getJSONObject("Message").getJSONObject("Body");
                if(bodyinfo!=null){
                    String errcode =bodyinfo.getString("errorcode");
                    boolean isupdate = false;
                    if ("FIN0000".equals(errcode)) {//已查询到，不代表支付成功
                        String zfstatus = bodyinfo.getString("status");
                        String errormsg =bodyinfo.getString("remark3");
                        if("U".equals(zfstatus)){//在途
                            //判断原因是否有变化
                           String sbyy =  dataEntity.getString("nckd_sbyy");
                           if(errormsg!=null&&errormsg.equals(sbyy)){//相等
                           }else{
                               dataEntity.set("nckd_sbyy",errormsg);//错误信息更新
                               isupdate = true;
                           }
                        }else if("S".equals(zfstatus)){//成功
                            dataEntity.set("nckd_paystatus",3);
                            dataEntity.set("nckd_sbyy","支付成功");//错误信息更新
                            isupdate = true;
                        }else if("F".equals(zfstatus)){//失败
                            dataEntity.set("nckd_paystatus",4);//支付失败
                            dataEntity.set("nckd_sbyy",errormsg);//错误信息更新
                            isupdate = true;
                        }
                        if(isupdate){
                            SaveServiceHelper.update(new DynamicObject[]{dataEntity});
                            PayBillToolUtil.saveupdatelog(dataEntity,bodyxml,cbsReturnJson.toString());
                        }
                    }
                }
            }
        }
    }
}
